package test;

import static org.junit.Assert.assertEquals;

import java.io.IOException;

import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.json.JSONException;
import org.json.JSONObject;
import org.junit.jupiter.api.Test;

import scenari.Automa;
import scenari.Scenari;
import utility.Esecutore;
import utility.SubscribeCallback;

public class AutomaTest {
	
	
//	@Test
	void test01() throws JSONException, IOException {
		Automa a = new Automa();
		JSONObject loff = new JSONObject().put("learn","off");
		JSONObject lon = new JSONObject().put("learn","on");
		JSONObject aoff = new JSONObject().put("antifurto","off");
		JSONObject aon = new JSONObject().put("antifurto","on");
		final int stato = a.getStato();
		a.setStato(loff.toString());
		a.setStato(aoff.toString());
//		valid commands
		assertEquals(0,a.getStato());
		a.setStato(lon.toString());
		assertEquals(1,a.getStato());
		a.setStato(loff.toString());
		assertEquals(0,a.getStato());
		a.setStato(aon.toString());
		assertEquals(2,a.getStato());
		a.setStato(aoff.toString());
		assertEquals(0,a.getStato());
//		invalid commands
		a.setStato(loff.toString());
		assertEquals(0,a.getStato());
		a.setStato(aoff.toString());
		assertEquals(0,a.getStato());
		a.setStato(lon.toString());
		assertEquals(1,a.getStato());
		a.setStato(lon.toString());
		assertEquals(1,a.getStato());
		a.setStato(aoff.toString());
		assertEquals(1,a.getStato());
		a.setStato(aon.toString());//secondo me questo dovrebbe essere valido
		assertEquals(1,a.getStato());
		a.setStato(loff.toString());
		a.setStato(aon.toString());
		assertEquals(2,a.getStato());
		a.setStato(lon.toString());
		assertEquals(2,a.getStato());
		a.setStato(loff.toString());
		assertEquals(2,a.getStato());
		a.setStato(aon.toString());
		assertEquals(2,a.getStato());
		a.setStato(null);
		assertEquals(2,a.getStato());
		a.setStato("\"antifurto\":\"on\"");
		assertEquals(2,a.getStato());
		a.setStato("{\"dati\":\"on\"}");
		assertEquals(2,a.getStato());
		a.setStato("{\"antifurto\":true}");
		assertEquals(2,a.getStato());
		
		resetStato(stato,a,loff,aoff,lon,aon);
	}

	private void resetStato(int stato,Automa a, JSONObject loff, JSONObject aoff, JSONObject lon, JSONObject aon) {
		switch (stato) {
			case 0: {
				a.setStato(loff.toString());
				a.setStato(aoff.toString());
				break;
			}
			case 1: {
				resetStato(0,a, aon, aon, aon, aon);
				a.setStato(lon.toString());
				break;
			}
			case 2: {
				resetStato(0,a, aon, aon, aon, aon);
				a.setStato(aon.toString());
				break;
			}
		}
	}
	
//	@Test
//	void test02() throws JSONException, IOException, MqttException {
//		Automa a = new Automa();
//		a.setStato("{\"learn\":\"on\"}");
//		SubscribeCallback sb = new SubscribeCallback(new Scenari(a), "IN4", "IN5", new Esecutore(a), a);
////		sb.handleEvent(1, "IN4");
//		MqttMessage mes = new MqttMessage();
//		mes.setPayload("{\"event\":0}".getBytes());
//		sb.messageArrived("from/gruppo2/luci/gpio/OUT3", mes);
//	}

}
